unit FileUnits;

interface

uses
  Classes;

type
  TFileNet = class(TThread)
  private
    { Private declarations }
    TotalBytes : cardinal;
  protected
    procedure Execute; override;
    procedure UpdateCaption;
  public
    constructor Create (FName : string; TrfTipo : Byte);
  end;

implementation

Uses WinSock, ServCliente, Windows, SysUtils;

var
  TrnfType : Byte;
  FileName : string;

constructor TFileNet.Create (FName : string; TrfTipo : Byte);
begin
  FileName := FName;
  TrnfType := TrfTipo;
  inherited Create(False);
end;

procedure TFileNet.UpdateCaption;
begin
  Form1.Caption := 'Bytes Leiddos::: ' + IntToStr(TotalBytes);
end;

procedure TFileNet.Execute;
var
  addr : TSockAddrIn;
  retval, sinsize, Port : Integer;
  sockerz, newsock : TSocket;
  InitDllSock : TWSAData;
  //Copia de archivo
  SrcFile : file;
  Buffile: array[1..1024] of Char;
  BytesRead : Integer;
begin
  //FileName := 'c:\nada.doc';
  //TrnfType := 1;
  WSAStartup($101, InitDllSock);
  addr.sin_family := AF_INET;
  addr.sin_port := htons(1122);
  addr.sin_addr.S_addr := inet_addr(PChar(Form1.IPnum.Text));
  //Abre el socket
  sockerz :=  socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
  sinsize:=SizeOf(addr);
  Form1.Caption := 'Conectando...';
  retval:=Connect(sockerz, addr, sinsize);
  If TrnfType = 0 then begin   {Funcion Put - UPLOAD}
    try
      AssignFile(SrcFile, FileName);
      Reset(SrcFile, 1);
    except Exit;
    end;
    Sleep(150);
    repeat
      BlockRead(SrcFile, Buffile, SizeOf(Buffile), BytesRead);
      TotalBytes := (TotalBytes + BytesRead);
      Synchronize(UpdateCaption);
      retval:=Send(sockerz, Buffile, BytesRead, 0);
    until EOF(SrcFile);
  end else begin   {Funcion Get - DOWNLOAD}
    try
      AssignFile(SrcFile, FileName);
      Rewrite(SrcFile, 1);
    except
      Exit;
    end;
    repeat
      BytesRead := Recv(sockerz, Buffile, SizeOf(Buffile), 0);
      TotalBytes := (TotalBytes + BytesRead);
      Synchronize(UpdateCaption);
      BlockWrite(SrcFile, Buffile, BytesRead, retval);
    until (BytesRead = -1) or (BytesRead = 0);
  end;
  CloseFile(SrcFile);
  //DataRet := IntToStr(retval);
  try CloseSocket(sockerz);
  except end;
end;

end.
